# -----------------------------------------------------------------------------
# $Id: Nick.pm 869 2005-03-27 08:52:27Z topia $
# -----------------------------------------------------------------------------
package User::Away::Nick;
use strict;
use warnings;
use base qw(Module);
use Mask;
use Multicast;

sub message_arrived {
    my ($this,$msg,$sender) = @_;

    # 饤ȤäNICKˤΤȿ롣
    if ($sender->isa('IrcIO::Client') &&
	$msg->command eq 'NICK') {

	my $set_away;
	foreach ($this->config->away('all')) {
	    my ($mask,$away_str) = m/^(.+?)\s+(.+)$/;
	    if (Mask::match($mask,$msg->param(0))) {
		$this->set_away($msg,$away_str);
		$set_away = 1;
		last;
	    }
	}
	if (!$set_away) {
	    $this->unset_away($msg);
	}
    }
    $msg;
}

sub set_away {
    my ($this,$msg,$away_str) = @_;
    $this->away($msg,
		$this->construct_irc_message(
		    Command => 'AWAY',
		    Param => $away_str));
}

sub unset_away {
    my ($this,$msg) = @_;
    $this->away($msg,
		$this->construct_irc_message(
		    Command => 'AWAY'));
}

sub away {
    my ($this,$msg,$away_msg) = @_;
    # NICK hoge@ircnetΤ褦˥ͥåȥ̾Ƥϡ
    # ƤΥСФAWAYȯԤ롣
    # Ǥʤ줿ͥåȥˤΤAWAYȯԤ롣
    
    my (undef,$network_name,$specified) = Multicast::detach($msg->param(0));
    if ($specified) {
	# 줿
	my $network = RunLoop->shared->network($network_name);
	if (defined $network) {
	    $network->send_message($away_msg);
	}
    }
    else {
	# ʤä
	RunLoop->shared->broadcast_to_servers($away_msg);
    }
}

1;

=pod
info: ˥å͡ѹ˱ AWAY ꤷޤ
default: off
section: important

# ˥å͡ѹȤˡΥ˥å͡бAWAY
# ꤵƤСAWAYꤷޤǤʤAWAYäޤ

# : <nickΥޥ> <ꤹAWAYå>
#
# nickhoge_zzzѹȡֿƤפȤAWAYꤹ롣
# hoge_workޤhoge_zzzѹϡֻŻפȤAWAYꤹ롣
# ʳnickѹAWAYä
# ԤɽѤơaway: re:hoge_(work|zzz) ŻפȤƤɤ
-away: hoge_zzz           Ƥ
-away: hoge_work,hoge_zzz Ż
=cut
